diff -r e279cd5bf8c7 -r c1cc5ea70ee2 nuxeo-platform-notification-core/src/main/java/org/nuxeo/ecm/platform/ec/notification/service/NotificationService.java
--- a/nuxeo-platform-notification-core/src/main/java/org/nuxeo/ecm/platform/ec/notification/service/NotificationService.java	Fri Mar 26 08:07:51 2010 +0100
+++ b/nuxeo-platform-notification-core/src/main/java/org/nuxeo/ecm/platform/ec/notification/service/NotificationService.java	Fri Mar 26 09:05:32 2010 +0100
@@ -69,488 +69,529 @@
  * @author <a href="mailto:npaslaru@nuxeo.com">Narcis Paslaru</a>
  * 
  */
-public class NotificationService extends DefaultComponent implements NotificationManager {
+public class NotificationService extends DefaultComponent implements
+        NotificationManager {
 
-	public static final ComponentName NAME = new ComponentName("org.nuxeo.ecm.platform.ec.notification.service.NotificationService");
+    public static final ComponentName NAME = new ComponentName(
+            "org.nuxeo.ecm.platform.ec.notification.service.NotificationService");
 
-	private static final Log log = LogFactory.getLog(NotificationService.class);
+    private static final Log log = LogFactory.getLog(NotificationService.class);
 
-	protected EmailHelper emailHelper = new EmailHelper();
-	
-	public static final String SUBSCRIPTION_NAME = "UserSubscription";
+    protected EmailHelper emailHelper = new EmailHelper();
 
-	// FIXME: performance issue when putting URLs in a Map.
-	protected static final Map<String, URL> TEMPLATES_MAP = new HashMap<String, URL>();
+    public static final String SUBSCRIPTION_NAME = "UserSubscription";
 
-	protected GeneralSettingsDescriptor generalSettings;
+    // FIXME: performance issue when putting URLs in a Map.
+    protected static final Map<String, URL> TEMPLATES_MAP = new HashMap<String, URL>();
 
-	protected NotificationRegistry notificationRegistry;
+    protected GeneralSettingsDescriptor generalSettings;
 
-	protected DocumentViewCodecManager docLocator;
+    protected NotificationRegistry notificationRegistry;
 
-	protected DeferredNotificationHelper deferredHelper = new DeferredNotificationHelper();
+    protected DocumentViewCodecManager docLocator;
 
-	protected UserSettingsService userSettingsService;
+    protected DeferredNotificationHelper deferredHelper = new DeferredNotificationHelper();
 
-	@Override
-	@SuppressWarnings("unchecked")
-	public <T> T getAdapter(Class<T> adapter) {
-		if (adapter.isAssignableFrom(NotificationManager.class)) {
-			return (T) this;
-		}
-		return null;
-	}
+    protected UserSettingsService userSettingsService;
 
-	@Override
-	public void activate(ComponentContext context) throws Exception {
-		notificationRegistry = new NotificationRegistryImpl();
+    @Override
+    @SuppressWarnings("unchecked")
+    public <T> T getAdapter(Class<T> adapter) {
+        if (adapter.isAssignableFrom(NotificationManager.class)) {
+            return (T) this;
+        }
+        return null;
+    }
 
-		// init default settings
-		generalSettings = new GeneralSettingsDescriptor();
-		generalSettings.serverPrefix = "http://localhost:8080/nuxeo/";
-		generalSettings.eMailSubjectPrefix = "[Nuxeo]";
-		generalSettings.mailSessionJndiName = "java:/Mail";
-	}
+    @Override
+    public void activate(ComponentContext context) throws Exception {
+        notificationRegistry = new NotificationRegistryImpl();
 
-	@Override
-	public void deactivate(ComponentContext context) throws Exception {
-		notificationRegistry.clear();
-		notificationRegistry = null;
-	}
+        // init default settings
+        generalSettings = new GeneralSettingsDescriptor();
+        generalSettings.serverPrefix = "http://localhost:8080/nuxeo/";
+        generalSettings.eMailSubjectPrefix = "[Nuxeo]";
+        generalSettings.mailSessionJndiName = "java:/Mail";
+    }
 
-	@Override
-	public void registerExtension(Extension extension) throws Exception {
-		log.info("Registering notification extention");
-		String xp = extension.getExtensionPoint();
-		if ("notifications".equals(xp)) {
-			Object[] contribs = extension.getContributions();
-			for (Object contrib : contribs) {
-				try {
-					NotificationDescriptor notifDesc = (NotificationDescriptor) contrib;
-					notificationRegistry.registerNotification(notifDesc, getNames(notifDesc.getEvents()));
-				} catch (Exception e) {
-					log.error(e);
-				}
-			}
-		} else if ("templates".equals(xp)) {
-			Object[] contribs = extension.getContributions();
-			for (Object contrib : contribs) {
-				try {
-					TemplateDescriptor templateDescriptor = (TemplateDescriptor) contrib;
-					templateDescriptor.setContext(extension.getContext());
-					registerTemplate(templateDescriptor);
-				} catch (Exception e) {
-					log.error(e);
-				}
-			}
-		} else if ("generalSettings".equals(xp)) {
-			Object[] contribs = extension.getContributions();
-			for (Object contrib : contribs) {
-				try {
-					generalSettings = (GeneralSettingsDescriptor) contrib;
-				} catch (Exception e) {
-					log.error(e);
-				}
-			}
-		}
-	}
+    @Override
+    public void deactivate(ComponentContext context) throws Exception {
+        notificationRegistry.clear();
+        notificationRegistry = null;
+    }
 
-	private static List<String> getNames(List<NotificationEventDescriptor> events) {
-		List<String> eventNames = new ArrayList<String>();
-		for (NotificationEventDescriptor descriptor : events) {
-			eventNames.add(descriptor.name);
-		}
-		return eventNames;
-	}
+    @Override
+    public void registerExtension(Extension extension) throws Exception {
+        log.info("Registering notification extention");
+        String xp = extension.getExtensionPoint();
+        if ("notifications".equals(xp)) {
+            Object[] contribs = extension.getContributions();
+            for (Object contrib : contribs) {
+                try {
+                    NotificationDescriptor notifDesc = (NotificationDescriptor) contrib;
+                    notificationRegistry.registerNotification(notifDesc,
+                            getNames(notifDesc.getEvents()));
+                } catch (Exception e) {
+                    log.error(e);
+                }
+            }
+        } else if ("templates".equals(xp)) {
+            Object[] contribs = extension.getContributions();
+            for (Object contrib : contribs) {
+                try {
+                    TemplateDescriptor templateDescriptor = (TemplateDescriptor) contrib;
+                    templateDescriptor.setContext(extension.getContext());
+                    registerTemplate(templateDescriptor);
+                } catch (Exception e) {
+                    log.error(e);
+                }
+            }
+        } else if ("generalSettings".equals(xp)) {
+            Object[] contribs = extension.getContributions();
+            for (Object contrib : contribs) {
+                try {
+                    generalSettings = (GeneralSettingsDescriptor) contrib;
+                } catch (Exception e) {
+                    log.error(e);
+                }
+            }
+        }
+    }
 
-	@Override
-	public void unregisterExtension(Extension extension) throws Exception {
-		String xp = extension.getExtensionPoint();
-		if ("notifications".equals(xp)) {
-			Object[] contribs = extension.getContributions();
-			for (Object contrib : contribs) {
-				try {
-					NotificationDescriptor notifDesc = (NotificationDescriptor) contrib;
-					notificationRegistry.unregisterNotification(notifDesc, getNames(notifDesc.getEvents()));
-				} catch (Exception e) {
-					log.error(e);
-				}
-			}
-		} else if ("templates".equals(xp)) {
-			Object[] contribs = extension.getContributions();
-			for (Object contrib : contribs) {
-				try {
-					TemplateDescriptor templateDescriptor = (TemplateDescriptor) contrib;
-					templateDescriptor.setContext(extension.getContext());
-					unregisterTemplate(templateDescriptor);
-				} catch (Exception e) {
-					log.error(e);
-				}
-			}
-		}
-	}
+    private static List<String> getNames(
+            List<NotificationEventDescriptor> events) {
+        List<String> eventNames = new ArrayList<String>();
+        for (NotificationEventDescriptor descriptor : events) {
+            eventNames.add(descriptor.name);
+        }
+        return eventNames;
+    }
 
-	public NotificationRegistry getNotificationRegistry() {
-		return notificationRegistry;
-	}
+    @Override
+    public void unregisterExtension(Extension extension) throws Exception {
+        String xp = extension.getExtensionPoint();
+        if ("notifications".equals(xp)) {
+            Object[] contribs = extension.getContributions();
+            for (Object contrib : contribs) {
+                try {
+                    NotificationDescriptor notifDesc = (NotificationDescriptor) contrib;
+                    notificationRegistry.unregisterNotification(notifDesc,
+                            getNames(notifDesc.getEvents()));
+                } catch (Exception e) {
+                    log.error(e);
+                }
+            }
+        } else if ("templates".equals(xp)) {
+            Object[] contribs = extension.getContributions();
+            for (Object contrib : contribs) {
+                try {
+                    TemplateDescriptor templateDescriptor = (TemplateDescriptor) contrib;
+                    templateDescriptor.setContext(extension.getContext());
+                    unregisterTemplate(templateDescriptor);
+                } catch (Exception e) {
+                    log.error(e);
+                }
+            }
+        }
+    }
 
-	public List<String> getSubscribers(String notification, String docId) throws ClientException {
-		PlacefulService service;
-		try {
-			service = NotificationServiceHelper.getPlacefulService();
-		} catch (Exception e) {
-			throw new ClientException(e);
-		}
-		String className = service.getAnnotationRegistry().get(SUBSCRIPTION_NAME);
-		// Class klass =
-		// Thread.currentThread().getContextClassLoader().loadClass(className);
-		String shortClassName = className.substring(className.lastIndexOf('.') + 1);
+    public NotificationRegistry getNotificationRegistry() {
+        return notificationRegistry;
+    }
 
-		Map<String, Object> paramMap = new HashMap<String, Object>();
-		paramMap.put("notification", notification);
-		paramMap.put("docId", docId);
+    public List<String> getSubscribers(String notification, String docId)
+            throws ClientException {
+        PlacefulService service;
+        try {
+            service = NotificationServiceHelper.getPlacefulService();
+        } catch (Exception e) {
+            throw new ClientException(e);
+        }
+        String className = service.getAnnotationRegistry().get(
+                SUBSCRIPTION_NAME);
+        // Class klass =
+        // Thread.currentThread().getContextClassLoader().loadClass(className);
+        String shortClassName = className.substring(className.lastIndexOf('.') + 1);
 
-		PlacefulService serviceBean = NotificationServiceHelper.getPlacefulServiceBean();
-		List<Annotation> subscriptions = new ArrayList<Annotation>();
-		subscriptions = serviceBean.getAnnotationListByParamMap(paramMap, shortClassName);
-		List<String> subscribers = new ArrayList<String>();
-		for (Object obj : subscriptions) {
-			UserSubscription subscription = (UserSubscription) obj;
-			subscribers.add(subscription.getUserId());
-		}
-		return subscribers;
-	}
+        Map<String, Object> paramMap = new HashMap<String, Object>();
+        paramMap.put("notification", notification);
+        paramMap.put("docId", docId);
 
-	public List<String> getSubscriptionsForUserOnDocument(String username, String docId) throws ClassNotFoundException,
-			ClientException {
-		PlacefulService service;
-		try {
-			service = NotificationServiceHelper.getPlacefulService();
-		} catch (Exception e) {
-			throw new ClientException(e);
-		}
-		String className = service.getAnnotationRegistry().get(SUBSCRIPTION_NAME);
-		// Class klass =
-		// Thread.currentThread().getContextClassLoader().loadClass(className);
-		String shortClassName = className.substring(className.lastIndexOf('.') + 1);
+        PlacefulService serviceBean = NotificationServiceHelper.getPlacefulServiceBean();
+        List<Annotation> subscriptions = new ArrayList<Annotation>();
+        subscriptions = serviceBean.getAnnotationListByParamMap(paramMap,
+                shortClassName);
+        List<String> subscribers = new ArrayList<String>();
+        for (Object obj : subscriptions) {
+            UserSubscription subscription = (UserSubscription) obj;
+            subscribers.add(subscription.getUserId());
+        }
+        return subscribers;
+    }
 
-		Map<String, Object> paramMap = new HashMap<String, Object>();
-		if (username != null) {
-			paramMap.put("userId", username);
-		}
-		if (docId != null) {
-			paramMap.put("docId", docId);
-		}
-		PlacefulService serviceBean = NotificationServiceHelper.getPlacefulServiceBean();
+    public List<String> getSubscriptionsForUserOnDocument(String username,
+            String docId) throws ClassNotFoundException, ClientException {
+        PlacefulService service;
+        try {
+            service = NotificationServiceHelper.getPlacefulService();
+        } catch (Exception e) {
+            throw new ClientException(e);
+        }
+        String className = service.getAnnotationRegistry().get(
+                SUBSCRIPTION_NAME);
+        // Class klass =
+        // Thread.currentThread().getContextClassLoader().loadClass(className);
+        String shortClassName = className.substring(className.lastIndexOf('.') + 1);
 
-		List<Annotation> subscriptions = serviceBean.getAnnotationListByParamMap(paramMap, shortClassName);
-		List<String> subscribers = new ArrayList<String>();
-		for (Object obj : subscriptions) {
-			UserSubscription subscription = (UserSubscription) obj;
-			subscribers.add(subscription.getNotification());
-		}
-		return subscribers;
-	}
+        Map<String, Object> paramMap = new HashMap<String, Object>();
+        if (username != null) {
+            paramMap.put("userId", username);
+        }
+        if (docId != null) {
+            paramMap.put("docId", docId);
+        }
+        PlacefulService serviceBean = NotificationServiceHelper.getPlacefulServiceBean();
 
-	public void addSubscription(String username, String notification, DocumentModel doc, Boolean sendConfirmationEmail,
-			NuxeoPrincipal principal, String notificationName) throws ClientException {
+        List<Annotation> subscriptions = serviceBean.getAnnotationListByParamMap(
+                paramMap, shortClassName);
+        List<String> subscribers = new ArrayList<String>();
+        for (Object obj : subscriptions) {
+            UserSubscription subscription = (UserSubscription) obj;
+            subscribers.add(subscription.getNotification());
+        }
+        return subscribers;
+    }
 
-		PlacefulService serviceBean = NotificationServiceHelper.getPlacefulServiceBean();
-		UserSubscription subscription = new UserSubscription(notification, username, doc.getId());
-		serviceBean.setAnnotation(subscription);
+    public void addSubscription(String username, String notification,
+            DocumentModel doc, Boolean sendConfirmationEmail,
+            NuxeoPrincipal principal, String notificationName)
+            throws ClientException {
 
-		// send event for email if necessary
-		if (sendConfirmationEmail) {
-			raiseConfirmationEvent(principal, doc, username, notificationName);
-		}
-	}
+        PlacefulService serviceBean = NotificationServiceHelper.getPlacefulServiceBean();
+        UserSubscription subscription = new UserSubscription(notification,
+                username, doc.getId());
+        serviceBean.setAnnotation(subscription);
 
-	protected EventProducer producer;
+        // send event for email if necessary
+        if (sendConfirmationEmail) {
+            raiseConfirmationEvent(principal, doc, username, notificationName);
+        }
+    }
 
-	protected void doFireEvent(Event event) throws ClientException {
-		if (producer == null) {
-			try {
-				producer = Framework.getService(EventProducer.class);
-			} catch (Exception e) {
-				throw new ClientRuntimeException("Unable to get MessageProducer : ", e);
-			}
-		}
-		producer.fireEvent(event);
-	}
+    protected EventProducer producer;
 
-	private void raiseConfirmationEvent(NuxeoPrincipal principal, DocumentModel doc, String username, String notification) {
+    protected void doFireEvent(Event event) throws ClientException {
+        if (producer == null) {
+            try {
+                producer = Framework.getService(EventProducer.class);
+            } catch (Exception e) {
+                throw new ClientRuntimeException(
+                        "Unable to get MessageProducer : ", e);
+            }
+        }
+        producer.fireEvent(event);
+    }
 
-		Map<String, Serializable> options = new HashMap<String, Serializable>();
+    private void raiseConfirmationEvent(NuxeoPrincipal principal,
+            DocumentModel doc, String username, String notification) {
 
-		// Name of the current repository
-		options.put(CoreEventConstants.REPOSITORY_NAME, doc.getRepositoryName());
+        Map<String, Serializable> options = new HashMap<String, Serializable>();
 
-		// Add the session ID
-		options.put(CoreEventConstants.SESSION_ID, doc.getSessionId());
+        // Name of the current repository
+        options.put(CoreEventConstants.REPOSITORY_NAME, doc.getRepositoryName());
 
-		// options for confirmation email
-		options.put("recipients", username);
-		options.put("notifName", notification);
+        // Add the session ID
+        options.put(CoreEventConstants.SESSION_ID, doc.getSessionId());
 
-		CoreSession session = CoreInstance.getInstance().getSession(doc.getSessionId());
-		DocumentEventContext ctx = new DocumentEventContext(session, principal, doc);
-		ctx.setCategory(DocumentEventCategories.EVENT_CLIENT_NOTIF_CATEGORY);
-		ctx.setProperties(options);
-		Event event = ctx.newEvent(DocumentEventTypes.SUBSCRIPTION_ASSIGNED);
+        // options for confirmation email
+        options.put("recipients", username);
+        options.put("notifName", notification);
 
-		try {
-			doFireEvent(event);
-		} catch (ClientException e) {
-			throw new ClientRuntimeException("Cannot fire event " + event, e);
-		}
-	}
+        CoreSession session = CoreInstance.getInstance().getSession(
+                doc.getSessionId());
+        DocumentEventContext ctx = new DocumentEventContext(session, principal,
+                doc);
+        ctx.setCategory(DocumentEventCategories.EVENT_CLIENT_NOTIF_CATEGORY);
+        ctx.setProperties(options);
+        Event event = ctx.newEvent(DocumentEventTypes.SUBSCRIPTION_ASSIGNED);
 
-	public void removeSubscription(String username, String notification, String docId) throws ClientException {
-		PlacefulService serviceBean = NotificationServiceHelper.getPlacefulServiceBean();
-		Map<String, Object> paramMap = new HashMap<String, Object>();
-		paramMap.put("userId", username);
-		paramMap.put("docId", docId);
-		paramMap.put("notification", notification);
+        try {
+            doFireEvent(event);
+        } catch (ClientException e) {
+            throw new ClientRuntimeException("Cannot fire event " + event, e);
+        }
+    }
 
-		serviceBean.removeAnnotationListByParamMap(paramMap, SUBSCRIPTION_NAME);
-		/*
-		 * List<Annotation> subscriptions = serviceBean
-		 * .getAnnotationListByParamMap(paramMap, SUBSCRIPTION_NAME); if
-		 * (subscriptions != null && subscriptions.size() > 0) { for (Annotation
-		 * subscription : subscriptions) { if (subscription != null) {
-		 * serviceBean.removeAnnotation(subscription); } } }
-		 */
-	}
+    public void removeSubscription(String username, String notification,
+            String docId) throws ClientException {
+        PlacefulService serviceBean = NotificationServiceHelper.getPlacefulServiceBean();
+        Map<String, Object> paramMap = new HashMap<String, Object>();
+        paramMap.put("userId", username);
+        paramMap.put("docId", docId);
+        paramMap.put("notification", notification);
 
-	public List<String> getUsersSubscribedToNotificationOnDocument(String notification, String docId) throws ClientException {
-		PlacefulService serviceBean = NotificationServiceHelper.getPlacefulServiceBean();
-		Map<String, Object> paramMap = new HashMap<String, Object>();
-		paramMap.put("docId", docId);
-		paramMap.put("notification", notification);
-		List<String> subscribers = new ArrayList<String>();
-		List<Annotation> subscriptions = serviceBean.getAnnotationListByParamMap(paramMap, SUBSCRIPTION_NAME);
-		for (Annotation annoSubscription : subscriptions) {
-			UserSubscription subscription = (UserSubscription) annoSubscription;
-			subscribers.add(subscription.getUserId());
-		}
-		return subscribers;
-	}
+        serviceBean.removeAnnotationListByParamMap(paramMap, SUBSCRIPTION_NAME);
+        /*
+         * List<Annotation> subscriptions = serviceBean
+         * .getAnnotationListByParamMap(paramMap, SUBSCRIPTION_NAME); if
+         * (subscriptions != null && subscriptions.size() > 0) { for (Annotation
+         * subscription : subscriptions) { if (subscription != null) {
+         * serviceBean.removeAnnotation(subscription); } } }
+         */
+    }
 
-	private static void registerTemplate(TemplateDescriptor td) {
-		if (td.src != null && td.src.length() > 0) {
-			URL url = td.getContext().getResource(td.src);
-			TEMPLATES_MAP.put(td.name, url);
-		}
-	}
+    public List<String> getUsersSubscribedToNotificationOnDocument(
+            String notification, String docId) throws ClientException {
+        PlacefulService serviceBean = NotificationServiceHelper.getPlacefulServiceBean();
+        Map<String, Object> paramMap = new HashMap<String, Object>();
+        paramMap.put("docId", docId);
+        paramMap.put("notification", notification);
+        List<String> subscribers = new ArrayList<String>();
+        List<Annotation> subscriptions = serviceBean.getAnnotationListByParamMap(
+                paramMap, SUBSCRIPTION_NAME);
+        for (Annotation annoSubscription : subscriptions) {
+            UserSubscription subscription = (UserSubscription) annoSubscription;
+            subscribers.add(subscription.getUserId());
+        }
+        return subscribers;
+    }
 
-	private static void unregisterTemplate(TemplateDescriptor td) {
-		if (td.name != null) {
-			TEMPLATES_MAP.remove(td.name);
-		}
-	}
+    private static void registerTemplate(TemplateDescriptor td) {
+        if (td.src != null && td.src.length() > 0) {
+            URL url = td.getContext().getResource(td.src);
+            TEMPLATES_MAP.put(td.name, url);
+        }
+    }
 
-	public static URL getTemplateURL(String name) {
-		return TEMPLATES_MAP.get(name);
-	}
+    private static void unregisterTemplate(TemplateDescriptor td) {
+        if (td.name != null) {
+            TEMPLATES_MAP.remove(td.name);
+        }
+    }
 
-	public String getServerUrlPrefix() {
-		return generalSettings.getServerPrefix();
-	}
+    public static URL getTemplateURL(String name) {
+        return TEMPLATES_MAP.get(name);
+    }
 
-	public String getEMailSubjectPrefix() {
-		return generalSettings.getEMailSubjectPrefix();
-	}
+    public String getServerUrlPrefix() {
+        return generalSettings.getServerPrefix();
+    }
 
-	public String getMailSessionJndiName() {
-		return generalSettings.getMailSessionJndiName();
-	}
+    public String getEMailSubjectPrefix() {
+        return generalSettings.getEMailSubjectPrefix();
+    }
 
-	public Notification getNotificationByName(String selectedNotification) {
-		List<Notification> listNotif = notificationRegistry.getNotifications();
-		for (Notification notification : listNotif) {
-			if (notification.getName().equals(selectedNotification)) {
-				return notification;
-			}
-		}
-		return null;
-	}
+    public String getMailSessionJndiName() {
+        return generalSettings.getMailSessionJndiName();
+    }
 
-	public void sendNotification(String notificationName, Map<String, Object> infoMap, String userPrincipal) throws ClientException {
+    public Notification getNotificationByName(String selectedNotification) {
+        List<Notification> listNotif = notificationRegistry.getNotifications();
+        for (Notification notification : listNotif) {
+            if (notification.getName().equals(selectedNotification)) {
+                return notification;
+            }
+        }
+        return null;
+    }
 
-		AlertSettingsWrapper as = getAlertSettings(userPrincipal);
+    public void sendNotification(String notificationName,
+            Map<String, Object> infoMap, String userPrincipal)
+            throws ClientException {
 
-		String notificationPolicy = as.getNotificationPolicy();
+        AlertSettingsWrapper as = getAlertSettings(userPrincipal);
 
-		if (AlertSettingsType.NOTIFICATION_POLICY_BOTH.equals(notificationPolicy)) {
-			sendImmediateNotification(notificationName, infoMap, userPrincipal);
-			storeDeferredNotification(notificationName, infoMap, userPrincipal);
-		} else if (AlertSettingsType.NOTIFICATION_POLICY_SUMMARY.equals(notificationPolicy)) {
-			storeDeferredNotification(notificationName, infoMap, userPrincipal);
-		} else if (AlertSettingsType.NOTIFICATION_POLICY_IMMEDIATE.equals(notificationPolicy)) {
-			sendImmediateNotification(notificationName, infoMap, userPrincipal);
-		} else {
-			log.warn(String.format("Unexpected value for notificationPolicy : %s", as.getNotificationPolicy()));
-			sendImmediateNotification(notificationName, infoMap, userPrincipal);
-		}
+        String notificationPolicy = as.getNotificationPolicy();
 
-	}
+        if (AlertSettingsType.NOTIFICATION_POLICY_BOTH.equals(notificationPolicy)) {
+            sendImmediateNotification(notificationName, infoMap, userPrincipal);
+            storeDeferredNotification(notificationName, infoMap, userPrincipal);
+        } else if (AlertSettingsType.NOTIFICATION_POLICY_SUMMARY.equals(notificationPolicy)) {
+            storeDeferredNotification(notificationName, infoMap, userPrincipal);
+        } else if (AlertSettingsType.NOTIFICATION_POLICY_IMMEDIATE.equals(notificationPolicy)) {
+            sendImmediateNotification(notificationName, infoMap, userPrincipal);
+        } else {
+            log.warn(String.format(
+                    "Unexpected value for notificationPolicy : %s",
+                    as.getNotificationPolicy()));
+            sendImmediateNotification(notificationName, infoMap, userPrincipal);
+        }
 
-	private void storeDeferredNotification(String notificationName, Map<String, Object> infoMap, String userPrincipal) throws ClientException {
-		
-		Notification notif = getNotificationByName(notificationName);
+    }
 
-		NuxeoPrincipal recepient = NotificationServiceHelper.getUsersService().getPrincipal(userPrincipal);
-		// XXX hack, principals have only one model
-		DataModel model = recepient.getModel().getDataModels().values().iterator().next();
-		String email = (String) model.getData("email");
-		String mailTemplate = "d_" + notif.getTemplate();
+    private void storeDeferredNotification(String notificationName,
+            Map<String, Object> infoMap, String userPrincipal)
+            throws ClientException {
 
-		infoMap.put("mail.to", email);
+        Notification notif = getNotificationByName(notificationName);
 
-		String authorUsername = (String) infoMap.get("author");
+        NuxeoPrincipal recepient = NotificationServiceHelper.getUsersService().getPrincipal(
+                userPrincipal);
+        // XXX hack, principals have only one model
+        DataModel model = recepient.getModel().getDataModels().values().iterator().next();
+        String email = (String) model.getData("email");
+        String mailTemplate = "d_" + notif.getTemplate();
 
-		if (authorUsername != null) {
-			NuxeoPrincipal author = NotificationServiceHelper.getUsersService().getPrincipal(authorUsername);
-			infoMap.put("principalAuthor", author);
-		}
+        infoMap.put("mail.to", email);
 
-		// mail.put("doc", docMessage); - should be already there
+        String authorUsername = (String) infoMap.get("author");
 
-		String subject = notif.getSubject() == null ? "Notification" : notif.getSubject();
-		if (notif.getSubjectTemplate() != null) {
-			subject = notif.getSubjectTemplate();
-		}
+        if (authorUsername != null) {
+            NuxeoPrincipal author = NotificationServiceHelper.getUsersService().getPrincipal(
+                    authorUsername);
+            infoMap.put("principalAuthor", author);
+        }
 
-		subject = NotificationServiceHelper.getNotificationService().getEMailSubjectPrefix() + subject;
+        // mail.put("doc", docMessage); - should be already there
 
-		infoMap.put("subject", subject);
-		infoMap.put("template", mailTemplate);
+        String subject = notif.getSubject() == null ? "Notification"
+                : notif.getSubject();
+        if (notif.getSubjectTemplate() != null) {
+            subject = notif.getSubjectTemplate();
+        }
 
-		try {
-			deferredHelper.storeNotification(infoMap, userPrincipal);
-		} catch (Exception e) {
-			throw new ClientException("Failed to send notification email ", e);
-		}
-	}
+        subject = NotificationServiceHelper.getNotificationService().getEMailSubjectPrefix()
+                + subject;
 
-	private AlertSettingsWrapper getAlertSettings(String userPrincipal) throws ClientException {
+        infoMap.put("subject", subject);
+        infoMap.put("template", mailTemplate);
 
-		DocumentModelList alertDocList = (DocumentModelList) getuserSettingsService().getUserSettings(userPrincipal, AlertSettingsType.DOCTYPE);
+        try {
+            deferredHelper.storeNotification(infoMap, userPrincipal);
+        } catch (Exception e) {
+            throw new ClientException("Failed to send notification email ", e);
+        }
+    }
 
-		DocumentModel alertDoc = alertDocList.get(0);
-		
-		return new AlertSettingsWrapper(alertDoc);
+    private AlertSettingsWrapper getAlertSettings(String userPrincipal)
+            throws ClientException {
 
+        DocumentModelList alertDocList = (DocumentModelList) getuserSettingsService().getUserSettings(
+                userPrincipal, AlertSettingsType.DOCTYPE);
 
-	}
+        DocumentModel alertDoc = alertDocList.get(0);
 
-	private UserSettingsService getuserSettingsService() throws ClientException {
+        return new AlertSettingsWrapper(alertDoc);
 
-		try {
-			if (userSettingsService == null) {
-				userSettingsService = Framework.getService(UserSettingsService.class);
-			}
+    }
 
-			return userSettingsService;
-		} catch (Exception e) {
-			throw new ClientException("Unable to get UserSettingsService", e);
-		}
+    private UserSettingsService getuserSettingsService() throws ClientException {
 
-	}
+        try {
+            if (userSettingsService == null) {
+                userSettingsService = Framework.getService(UserSettingsService.class);
+            }
 
-	private void sendImmediateNotification(String notificationName, Map<String, Object> infoMap, String userPrincipal)
-			throws ClientException, PropertyException {
-		Notification notif = getNotificationByName(notificationName);
+            return userSettingsService;
+        } catch (Exception e) {
+            throw new ClientException("Unable to get UserSettingsService", e);
+        }
 
-		NuxeoPrincipal recepient = NotificationServiceHelper.getUsersService().getPrincipal(userPrincipal);
-		// XXX hack, principals have only one model
-		DataModel model = recepient.getModel().getDataModels().values().iterator().next();
-		String email = (String) model.getData("email");
-		String mailTemplate = notif.getTemplate();
+    }
 
-		infoMap.put("mail.to", email);
+    private void sendImmediateNotification(String notificationName,
+            Map<String, Object> infoMap, String userPrincipal)
+            throws ClientException, PropertyException {
+        Notification notif = getNotificationByName(notificationName);
 
-		String authorUsername = (String) infoMap.get("author");
+        NuxeoPrincipal recepient = NotificationServiceHelper.getUsersService().getPrincipal(
+                userPrincipal);
+        // XXX hack, principals have only one model
+        DataModel model = recepient.getModel().getDataModels().values().iterator().next();
+        String email = (String) model.getData("email");
+        String mailTemplate = notif.getTemplate();
 
-		if (authorUsername != null) {
-			NuxeoPrincipal author = NotificationServiceHelper.getUsersService().getPrincipal(authorUsername);
-			infoMap.put("principalAuthor", author);
-		}
+        infoMap.put("mail.to", email);
 
-		// mail.put("doc", docMessage); - should be already there
+        String authorUsername = (String) infoMap.get("author");
 
-		String subject = notif.getSubject() == null ? "Notification" : notif.getSubject();
-		if (notif.getSubjectTemplate() != null) {
-			subject = notif.getSubjectTemplate();
-		}
+        if (authorUsername != null) {
+            NuxeoPrincipal author = NotificationServiceHelper.getUsersService().getPrincipal(
+                    authorUsername);
+            infoMap.put("principalAuthor", author);
+        }
 
-		subject = NotificationServiceHelper.getNotificationService().getEMailSubjectPrefix() + subject;
+        // mail.put("doc", docMessage); - should be already there
 
-		infoMap.put("subject", subject);
-		infoMap.put("template", mailTemplate);
+        String subject = notif.getSubject() == null ? "Notification"
+                : notif.getSubject();
+        if (notif.getSubjectTemplate() != null) {
+            subject = notif.getSubjectTemplate();
+        }
 
-		try {
-			emailHelper.sendmail(infoMap);
-		} catch (Exception e) {
-			throw new ClientException("Failed to send notification email ", e);
-		}
-	}
+        subject = NotificationServiceHelper.getNotificationService().getEMailSubjectPrefix()
+                + subject;
 
-	public void sendDocumentByMail(DocumentModel doc, String freemarkerTemplateName, String subject, String comment,
-			NuxeoPrincipal sender, List<String> sendTo) {
-		Map<String, Object> infoMap = new HashMap<String, Object>();
-		infoMap.put("document", doc);
-		infoMap.put("subject", subject);
-		infoMap.put("comment", comment);
-		infoMap.put("sender", sender);
+        infoMap.put("subject", subject);
+        infoMap.put("template", mailTemplate);
 
-		DocumentLocation docLoc = new DocumentLocationImpl(doc);
-		DocumentView docView = new DocumentViewImpl(docLoc);
-		docView.setViewId("view_documents");
-		infoMap.put("docUrl", getDocLocator().getUrlFromDocumentView(docView, true,
-				NotificationServiceHelper.getNotificationService().getServerUrlPrefix()));
+        try {
+            emailHelper.sendmail(infoMap);
+        } catch (Exception e) {
+            throw new ClientException("Failed to send notification email ", e);
+        }
+    }
 
-		if (freemarkerTemplateName == null) {
-			freemarkerTemplateName = "defaultNotifTemplate";
-		}
-		infoMap.put("template", freemarkerTemplateName);
+    public void sendDocumentByMail(DocumentModel doc,
+            String freemarkerTemplateName, String subject, String comment,
+            NuxeoPrincipal sender, List<String> sendTo) {
+        Map<String, Object> infoMap = new HashMap<String, Object>();
+        infoMap.put("document", doc);
+        infoMap.put("subject", subject);
+        infoMap.put("comment", comment);
+        infoMap.put("sender", sender);
 
-		for (String to : sendTo) {
-			infoMap.put("mail.to", to);
-			try {
-				emailHelper.sendmail(infoMap);
-			} catch (Exception e) {
-				log.debug("Failed to send notification email " + e);
-			}
-		}
-	}
+        DocumentLocation docLoc = new DocumentLocationImpl(doc);
+        DocumentView docView = new DocumentViewImpl(docLoc);
+        docView.setViewId("view_documents");
+        infoMap.put(
+                "docUrl",
+                getDocLocator().getUrlFromDocumentView(
+                        docView,
+                        true,
+                        NotificationServiceHelper.getNotificationService().getServerUrlPrefix()));
 
-	private DocumentViewCodecManager getDocLocator() {
-		if (docLocator == null) {
-			try {
-				docLocator = Framework.getService(DocumentViewCodecManager.class);
-			} catch (Exception e) {
-				log.info("Could not get service for document view manager");
-			}
-		}
+        if (freemarkerTemplateName == null) {
+            freemarkerTemplateName = "defaultNotifTemplate";
+        }
+        infoMap.put("template", freemarkerTemplateName);
 
-		return docLocator;
-	}
+        for (String to : sendTo) {
+            infoMap.put("mail.to", to);
+            try {
+                emailHelper.sendmail(infoMap);
+            } catch (Exception e) {
+                log.debug("Failed to send notification email " + e);
+            }
+        }
+    }
 
-	public List<Notification> getNotificationsForSubscriptions(String parentType) {
-		return notificationRegistry.getNotificationsForSubscriptions(parentType);
-	}
+    private DocumentViewCodecManager getDocLocator() {
+        if (docLocator == null) {
+            try {
+                docLocator = Framework.getService(DocumentViewCodecManager.class);
+            } catch (Exception e) {
+                log.info("Could not get service for document view manager");
+            }
+        }
 
-	public List<Notification> getNotificationsForEvents(String eventId) {
-		return notificationRegistry.getNotificationsForEvent(eventId);
-	}
+        return docLocator;
+    }
 
-	public EmailHelper getEmailHelper() {
-		return emailHelper;
-	}
+    public List<Notification> getNotificationsForSubscriptions(String parentType) {
+        return notificationRegistry.getNotificationsForSubscriptions(parentType);
+    }
 
-	public void setEmailHelper(EmailHelper emailHelper) {
-		this.emailHelper = emailHelper;
-	}
+    public List<Notification> getNotificationsForEvents(String eventId) {
+        return notificationRegistry.getNotificationsForEvent(eventId);
+    }
+
+    public EmailHelper getEmailHelper() {
+        return emailHelper;
+    }
+
+    public void setEmailHelper(EmailHelper emailHelper) {
+        this.emailHelper = emailHelper;
+    }
 
 }
